
/*  A Bison parser, made from macro.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOKEN_IDENTIFIER	257
#define	TOKEN_MACRO	258
#define	TOKEN_ENDMACRO	259
#define	TOKEN_IMMEDIATE	260
#define	TOKEN_PARAM	261
#define	TOKEN_NEWLINE	262
#define	TOKEN_COMMA	263
#define	TOKEN_INCLUDE	264
#define	TOKEN_NUMBER	265
#define	TOKEN_EQUATE	266
#define	TOKEN_DOLLAR	267
#define	TOKEN_DOLLAR_EX	268
#define	TOKEN_INDIRECT	269
#define	TOKEN_CODE	270
#define	TOKEN_LOCAL	271
#define	TOKEN_END	272
#define	TOKEN_AND	273
#define	TOKEN_OR	274
#define	TOKEN_SHL	275
#define	TOKEN_SHR	276
#define	TOKEN_HIGH	277
#define	TOKEN_LOW	278
#define	TOKEN_NOT	279
#define	TOKEN_SEGMENT	280
#define	TOKEN_SEGMENT_TYPE	281
#define	TOKEN_SEGMENT_SELECT	282
#define	TOKEN_AT	283
#define	TOKEN_RSEG	284
#define	TOKEN_ORG	285
#define	TOKEN_BIT	286


/***************************************************************************/
/*************************** begin yacc declarations ***********************/
/***************************************************************************/

#include "macro.h"

int yyparse (void);
int yyerror (char *mesg);

extern  BOOL  InsertMacro();
extern  void  InitMacros();
extern  void  FreeMacros();
extern  BOOL  InsertEquate();
extern  void  InitEquates();
extern  void  FreeEquates();

#ifndef WIN32

#define SOLARIS
#ifdef SOLARIS // these values were pulled out of the air -> Find out the
               // true values NOW!!!
#define _MAX_PATH   255 /* max. length of full pathname */
#define _MAX_DRIVE  3   /* max. length of drive component */
#define _MAX_DIR    255 /* max. length of path component */
#define _MAX_FNAME  256 /* max. length of file name component */
#define _MAX_EXT    256 /* max. length of extension component */
#endif /* SOLARIS */
#endif /* !WIN32 */

#define WILDCARDS 0x01
#define EXTENSION 0x02
#define FILENAME  0x04
#define DIRECTORY 0x08
#define DRIVE     0x10

extern  FILE    *yyin, *g_lpOutFile;
extern  int     g_LineNumber;
extern  int     g_ExpressionValue;
extern  char    *yytext;
extern  char    g_LabelPrefix[80];
extern  char    g_TempString[260];
extern  BOOL    g_KillEnd;
extern  BOOL    g_InMacro;
extern  BOOL    g_InEquate;
extern  BOOL    g_HaveBitDigit; 
extern  BOOL    g_InIncludeFile;
extern  int     g_NumberToResolve;
extern  MACRO   g_CurrentMacro;
extern  EQUATE  g_CurrentEquate;
extern  void    *g_lpVoidPtr;
extern  fpos_t  g_ExpressionPosition;
extern  LPREFERENCE_LIST  g_lpHoldReference;

int           g_BytesRead;
unsigned char g_TempBuff[1024];
BOOL          g_EndOfFile = FALSE;


extern  void        InitIncludeStack(void);
extern  BOOL        PushIncludeFile(char* p_lpFileName);
extern  BOOL        PopIncludeFile(void);
extern  const char  *GetCurrentFileName(void);
extern  FILE        *GetRootFile(void);

/*************************** end my yacc declarations **********************/
/***************************************************************************/

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		106
#define	YYFLAG		-32768
#define	YYNTBASE	39

#define YYTRANSLATE(x) ((unsigned)(x) <= 286 ? yytranslate[x] : 56)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    37,
    38,    35,    33,     2,    34,     2,    36,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     7,     9,    11,    14,    17,    20,
    24,    26,    29,    32,    35,    36,    39,    46,    50,    54,
    55,    58,    62,    65,    67,    69,    72,    75,    77,    79,
    80,    83,    86,    87,    90,    93,    95,    99,   103,   107,
   111,   115,   119,   123,   127,   132,   137,   142,   146,   148,
   151,   153,   156,   160,   164,   167,   170,   173,   176
};

static const short yyrhs[] = {    -1,
    18,     0,    42,     0,     8,     0,    43,     0,    16,     0,
     3,    32,     0,     3,    54,     0,     3,    55,     0,     3,
    26,    27,     0,    40,     0,    30,     3,     0,    31,    52,
     0,    28,    41,     0,     0,    29,    52,     0,     3,     4,
    46,    44,    50,     5,     0,     3,    12,    53,     0,     3,
    12,     3,     0,     0,    17,    45,     0,     3,     9,    45,
     0,     3,     8,     0,     8,     0,    47,     0,     7,    48,
     0,     3,    49,     0,     8,     0,    48,     0,     0,     3,
    51,     0,     8,    50,     0,     0,    54,    50,     0,    55,
    50,     0,    53,     0,    53,    33,    53,     0,    53,    34,
    53,     0,    53,    35,    53,     0,    53,    36,    53,     0,
    53,    19,    53,     0,    53,    20,    53,     0,    53,    22,
    53,     0,    53,    21,    53,     0,    23,    37,    53,    38,
     0,    24,    37,    53,    38,     0,    25,    37,    53,    38,
     0,    37,    53,    38,     0,    11,     0,     9,    55,     0,
     8,     0,     3,    54,     0,    36,     3,    54,     0,    36,
    52,    54,     0,     6,    54,     0,    15,    54,     0,    13,
    54,     0,    14,    54,     0,    52,    54,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   258,   262,   267,   271,   275,   279,   283,   287,   291,   295,
   299,   303,   307,   313,   316,   317,   320,   327,   345,   360,
   361,   364,   365,   368,   369,   372,   375,   384,   385,   388,
   389,   390,   393,   394,   395,   398,   438,   439,   440,   441,
   447,   448,   449,   450,   451,   452,   453,   454,   457,   462,
   463,   466,   467,   468,   469,   470,   471,   472,   473
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOKEN_IDENTIFIER",
"TOKEN_MACRO","TOKEN_ENDMACRO","TOKEN_IMMEDIATE","TOKEN_PARAM","TOKEN_NEWLINE",
"TOKEN_COMMA","TOKEN_INCLUDE","TOKEN_NUMBER","TOKEN_EQUATE","TOKEN_DOLLAR","TOKEN_DOLLAR_EX",
"TOKEN_INDIRECT","TOKEN_CODE","TOKEN_LOCAL","TOKEN_END","TOKEN_AND","TOKEN_OR",
"TOKEN_SHL","TOKEN_SHR","TOKEN_HIGH","TOKEN_LOW","TOKEN_NOT","TOKEN_SEGMENT",
"TOKEN_SEGMENT_TYPE","TOKEN_SEGMENT_SELECT","TOKEN_AT","TOKEN_RSEG","TOKEN_ORG",
"TOKEN_BIT","'+'","'-'","'*'","'/'","'('","')'","Start","SegSelection","SegAddress",
"Macro","Equate","LocalList","Locals","ParamList","Params","ParamEntry","ParamEntryNext",
"MacroBody","MacroEntry","ProcessExpression","Expression","CodeEntry","CodeEntryNext", NULL
};
#endif

static const short yyr1[] = {     0,
    39,    39,    39,    39,    39,    39,    39,    39,    39,    39,
    39,    39,    39,    40,    41,    41,    42,    43,    43,    44,
    44,    45,    45,    46,    46,    47,    48,    49,    49,    50,
    50,    50,    51,    51,    51,    52,    53,    53,    53,    53,
    53,    53,    53,    53,    53,    53,    53,    53,    53,    54,
    54,    55,    55,    55,    55,    55,    55,    55,    55
};

static const short yyr2[] = {     0,
     0,     1,     1,     1,     1,     1,     2,     2,     2,     3,
     1,     2,     2,     2,     0,     2,     6,     3,     3,     0,
     2,     3,     2,     1,     1,     2,     2,     1,     1,     0,
     2,     2,     0,     2,     2,     1,     3,     3,     3,     3,
     3,     3,     3,     3,     4,     4,     4,     3,     1,     2,
     1,     2,     3,     3,     2,     2,     2,     2,     2
};

static const short yydefact[] = {     1,
     0,     4,     6,     2,    15,     0,     0,    11,     3,     5,
     0,     0,     0,    51,     0,    49,     0,     0,     0,     0,
     0,     0,     0,     0,     7,     0,     0,     0,    36,     8,
     9,     0,    14,    12,    13,    52,     0,    24,    20,    25,
    55,    50,    19,    18,    57,    58,    56,     0,     0,     0,
    10,     0,     0,     0,    59,     0,     0,     0,     0,     0,
     0,     0,     0,    16,     0,    26,     0,    30,     0,     0,
     0,    53,    54,    48,    41,    42,    44,    43,    37,    38,
    39,    40,    28,    29,    27,     0,    21,    33,    30,     0,
    45,    46,    47,    23,     0,    31,    30,    30,    32,    17,
    22,    34,    35,     0,     0,     0
};

static const short yydefgoto[] = {   104,
     8,    33,     9,    10,    68,    87,    39,    40,    66,    85,
    90,    96,    28,    29,    30,    31
};

static const short yypact[] = {   107,
    55,-32768,-32768,-32768,   -16,    13,   103,-32768,-32768,-32768,
    24,    68,    24,-32768,    82,-32768,    79,    24,    24,    24,
   -18,   -15,   -10,     7,-32768,    97,   103,    24,   162,-32768,
-32768,   103,-32768,-32768,-32768,-32768,    54,-32768,    43,-32768,
-32768,-32768,-32768,   162,-32768,-32768,-32768,   103,   103,   103,
-32768,    24,    24,   110,-32768,   103,   103,   103,   103,   103,
   103,   103,   103,-32768,     2,-32768,    59,    12,   130,   136,
   156,-32768,-32768,-32768,    51,    62,    64,-32768,   166,   166,
    34,    34,-32768,-32768,-32768,    90,-32768,    15,    12,    60,
-32768,-32768,-32768,-32768,    59,-32768,    12,    12,-32768,-32768,
-32768,-32768,-32768,    89,    94,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,     6,-32768,-32768,    44,-32768,
   -86,-32768,    -1,   -13,   -11,   -14
};


#define	YYLAST		202


static const short yytable[] = {    36,
    42,    41,    99,    44,    65,    35,    45,    46,    47,    83,
   102,   103,    32,    54,    88,    34,    55,    11,    48,    89,
    13,    49,    14,    15,    53,    16,    50,    18,    19,    20,
    64,    14,    15,    51,    69,    70,    71,    21,    22,    23,
    72,    73,    75,    76,    77,    78,    79,    80,    81,    82,
    26,    27,    56,    57,    58,    59,    65,    11,    12,    67,
    13,    86,    14,    15,   100,    16,    17,    18,    19,    20,
    57,    58,    59,    98,    37,    38,    97,    21,    22,    23,
    24,    43,    58,    59,    11,    59,    25,    13,   105,    16,
    26,    27,    16,   106,    18,    19,    20,    94,    95,    52,
   101,    21,    22,    23,    21,    22,    23,    16,    84,     1,
     0,     0,     0,    16,     2,    27,     0,    26,    27,    21,
    22,    23,     3,     0,     4,    21,    22,    23,    56,    57,
    58,    59,     0,    27,     5,     0,     6,     7,     0,    27,
     0,     0,    60,    61,    62,    63,     0,    74,    56,    57,
    58,    59,     0,     0,    56,    57,    58,    59,     0,     0,
     0,     0,    60,    61,    62,    63,     0,    91,    60,    61,
    62,    63,     0,    92,    56,    57,    58,    59,     0,     0,
    56,    57,    58,    59,    56,    57,    58,    59,    60,    61,
    62,    63,     0,    93,    60,    61,    62,    63,     0,     0,
    62,    63
};

static const short yycheck[] = {    11,
    15,    13,    89,    17,     3,     7,    18,    19,    20,     8,
    97,    98,    29,    27,     3,     3,    28,     3,    37,     8,
     6,    37,     8,     9,    26,    11,    37,    13,    14,    15,
    32,     8,     9,    27,    48,    49,    50,    23,    24,    25,
    52,    53,    56,    57,    58,    59,    60,    61,    62,    63,
    36,    37,    19,    20,    21,    22,     3,     3,     4,    17,
     6,     3,     8,     9,     5,    11,    12,    13,    14,    15,
    20,    21,    22,    88,     7,     8,    88,    23,    24,    25,
    26,     3,    21,    22,     3,    22,    32,     6,     0,    11,
    36,    37,    11,     0,    13,    14,    15,     8,     9,     3,
    95,    23,    24,    25,    23,    24,    25,    11,    65,     3,
    -1,    -1,    -1,    11,     8,    37,    -1,    36,    37,    23,
    24,    25,    16,    -1,    18,    23,    24,    25,    19,    20,
    21,    22,    -1,    37,    28,    -1,    30,    31,    -1,    37,
    -1,    -1,    33,    34,    35,    36,    -1,    38,    19,    20,
    21,    22,    -1,    -1,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    33,    34,    35,    36,    -1,    38,    33,    34,
    35,    36,    -1,    38,    19,    20,    21,    22,    -1,    -1,
    19,    20,    21,    22,    19,    20,    21,    22,    33,    34,
    35,    36,    -1,    38,    33,    34,    35,    36,    -1,    -1,
    35,    36
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{
                                                              //printf("\nSuccess\n");
                                                              return 0;
                                                            ;
    break;}
case 2:
{
                                                              //printf(" \nDone\n");
                                                              g_EndOfFile = TRUE;
                                                              return 0;
                                                            ;
    break;}
case 3:
{
                                                              //printf("\nStart1\n");
                                                              return 0;
                                                            ;
    break;}
case 4:
{
                                                              //printf("\nStart2\n");
                                                              return 0;
                                                            ;
    break;}
case 5:
{
                                                              //printf("\nStart3\n");
                                                              return 0;
                                                            ;
    break;}
case 6:
{
                                                              //printf("\nStart4\n");
                                                              return 0;
                                                            ;
    break;}
case 7:
{
                                                              //printf("\nStart5\n");
                                                              return 0;
                                                            ;
    break;}
case 8:
{
                                                              //printf("\nStart6\n");
                                                              return 0;
                                                            ;
    break;}
case 9:
{
                                                              //printf("\nStart7\n");
                                                              return 0;
                                                            ;
    break;}
case 10:
{
                                                              //printf("\nStart8\n");
                                                              return 0;
                                                            ;
    break;}
case 11:
{
                                                              //printf("\nStart9\n");
                                                              return 0;
                                                            ;
    break;}
case 12:
{
                                                              //printf("\nStart10\n");
                                                              return 0;
                                                            ;
    break;}
case 13:
{
                                                              //printf("\nStart11\n");
                                                              return 0;
                                                            ;
    break;}
case 14:
{;
    break;}
case 16:
{;
    break;}
case 17:
{ /* store macro in table */ 
                                                              //printf("Got a macro ");
                                                              InsertMacro();
                                                            ;
    break;}
case 18:
{/* store equate in table */
                                                              if(g_InEquate)
                                                              {
                                                                if(g_HaveBitDigit)
                                                                {
                                                                  g_CurrentEquate.Value = g_NumberToResolve;
                                                                  g_HaveBitDigit = FALSE;

                                                                }
                                                                else
                                                                  g_CurrentEquate.Value = yyvsp[0];

                                                                g_InEquate = FALSE;
                                                              }

                                                              //printf("Got an equate ");
                                                              InsertEquate();
                                                            ;
    break;}
case 19:
{

                                                              g_CurrentEquate.Type = EQUATE_REFERENCE;
                                                              g_CurrentEquate.Reference = malloc(strlen(yytext)+1);

                                                              if(!g_CurrentEquate.Reference)
                                                                yyerror("Memory allocation error");

                                                              strcpy(g_CurrentEquate.Reference, yytext);
                                                              g_InEquate = FALSE;
                                                              //printf("Got an equate ");
                                                              InsertEquate();
                                                            ;
    break;}
case 21:
{;
    break;}
case 22:
{;
    break;}
case 23:
{;
    break;}
case 24:
{;
    break;}
case 25:
{;
    break;}
case 26:
{;
    break;}
case 27:
{ /* 
                                                               * add a parameter to the list 
                                                               * this is not called until
                                                               * all the params are parsed
                                                               * add parms in lex!!!
                                                               */
                                                            ;
    break;}
case 28:
{;
    break;}
case 29:
{;
    break;}
case 31:
{;
    break;}
case 32:
{;
    break;}
case 34:
{;
    break;}
case 35:
{;
    break;}
case 36:
{
                                                              //printf("PROCESSING EXPRESSION ");
                                                              if(g_InMacro)
                                                              {
//                                                                sprintf(g_TempString, "0%Xh %s", $1, yytext);
                                                                sprintf(g_TempString, "0%Xh", yyvsp[0]);
                                                                g_lpHoldReference->Reference.Pointer = malloc(strlen(g_TempString)+1);
                                                                strcpy((char *)(g_lpHoldReference->Reference.Pointer), g_TempString);
                                                              }
                                                              else if(g_InEquate)
                                                              {
                                                                g_CurrentEquate.Value = yyvsp[0];
                                                                g_InEquate = FALSE;
                                                              }
                                                              else
                                                              {
                                                                if(!g_InIncludeFile)
                                                                { 
                                                                  // we need to back up to the point where the
                                                                  // expression started and insert the resolved
                                                                  // number
                                                                  fsetpos(g_lpOutFile, &g_ExpressionPosition);
                                                                  g_BytesRead = fread(g_TempBuff, 1, sizeof(g_TempBuff), g_lpOutFile);
                                                                  fsetpos(g_lpOutFile, &g_ExpressionPosition);
                                                                  
                                                                  // this is a hack - it may not work for all cases
                                                                  if((*g_TempBuff == ',') && (*yytext == ','))
                                                                    fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                                                                  else if((*g_TempBuff == '.') && (*yytext == ','))
                                                                    fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                                                                  else if((g_TempBuff[strlen(g_TempBuff)-1] == '\n') && (*yytext == '\n'))
                                                                    fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                                                                  else
                                                                    fprintf(g_lpOutFile, "0%Xh%s", yyvsp[0], yytext);
                                                                  
                                                                  fwrite(g_TempBuff, g_BytesRead, 1, g_lpOutFile);
                                                                }
                                                              }
                                                            ;
    break;}
case 37:
{yyval = yyvsp[-2] + yyvsp[0];
    break;}
case 38:
{yyval = yyvsp[-2] - yyvsp[0];
    break;}
case 39:
{yyval = yyvsp[-2] * yyvsp[0];
    break;}
case 40:
{
                                                              if(yyvsp[0] == 0)
                                                                yyerror("Attempt to divide by zero");
                                                              else
                                                                yyval = yyvsp[-2] / yyvsp[0];
                                                            ;
    break;}
case 41:
{yyval = yyvsp[-2] & yyvsp[0];
    break;}
case 42:
{yyval = yyvsp[-2] | yyvsp[0];
    break;}
case 43:
{yyval = yyvsp[-2] >> yyvsp[0];
    break;}
case 44:
{yyval = yyvsp[-2] << yyvsp[0];
    break;}
case 45:
{yyval = (yyvsp[-1] >> 8) & 0x0ff;
    break;}
case 46:
{yyval = yyvsp[-1] & 0x0ff;
    break;}
case 47:
{yyval = (~(yyvsp[-1]&0x0ffffff) & 0x0ffffff);
    break;}
case 48:
{
                                                              yyval = yyvsp[-1];
                                                            ;
    break;}
case 49:
{
                                                              yyval = g_NumberToResolve;
                                                            ;
    break;}
case 50:
{;
    break;}
case 51:
{;
    break;}
case 52:
{;
    break;}
case 53:
{/* slash */;
    break;}
case 54:
{/* slash 2 */;
    break;}
case 55:
{;
    break;}
case 56:
{;
    break;}
case 57:
{;
    break;}
case 58:
{;
    break;}
case 59:
{;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}


/***********  Program Section  ***********/
/***************************************************************************/
/****************************** yacc entry point ***************************/
/***************************************************************************/
void static   SplitPath(const char *pathP,
                        char *driveP,     
                        char *dirP,
                        char *nameP, 
                        char *extP);

void  CloseOutputFile(void);
char  *g_FileName;
char  g_TempOutputFileName[_MAX_DIR];
char  g_OutputFileName[_MAX_DIR];
char  *g_Tmp;
char  g_OutputBuff[32768];

#define VERSION_MAJOR 0
#define VERSION_MINOR 110
#define BUILD "$Revision: 10 $"

void PrintBanner()
{
  char  l_lpBuild[] = BUILD;
  char  *l_lpTemp;

  fprintf(stderr,
          "ͻ\n"
          " Dallas Semiconductor DS80C390 Macro Preprocessor, Beta Version %d.%03d.%04u \n"
          "ͼ\n"
          "Last build %s at %s\n\n", 
          VERSION_MAJOR, 
          VERSION_MINOR, 
          strtol(strtok(l_lpBuild,"evision: $R"), &l_lpTemp, 10), 
          __DATE__, 
          __TIME__);
  
}

int main(int argc, char *argv[])
{
  char  l_Drive[_MAX_DRIVE];
  char  l_Dir[_MAX_DIR];
  char  l_Name[_MAX_FNAME];
  char  l_Ext[_MAX_EXT];
  char  l_QuietMode = 0;
  int   l_Strlen;
  int   l_RetVal;
  int   l_Count = 0;
  int   i;

  if(argc < 2)
  {
    PrintBanner();  
    fprintf(stderr, "Error, No file specified");
    return 1;
  }
 
  for(i = 1; i < argc; i++)
  { 
    if(argv[i][0] != '-')
      break;

    if(!strcmp(argv[i], "-E-"))
      g_KillEnd = TRUE;
    else if(!strcmp(argv[i], "-e-"))
      g_KillEnd = TRUE;
    else if(argv[i][1] == 'q')
      l_QuietMode = 1;
  }

  SplitPath(argv[argc-1],  
            l_Drive,
            l_Dir,
            l_Name,
            l_Ext);
  l_Strlen  = strlen(l_Name);
  memcpy(g_LabelPrefix, l_Name, l_Strlen);

  strcpy(g_OutputFileName, l_Name);
  strcat(g_OutputFileName, ".mpp");
  
  // this function reuses the filename buffer
  g_Tmp = tmpnam(NULL);
  // make a copy to prevent scroggage
  strcpy(g_TempOutputFileName, g_Tmp);

  remove(g_OutputFileName);
  
  if(!(g_lpOutFile = fopen(g_TempOutputFileName,"w+")))
  {
    PrintBanner();  
    fprintf(stderr, "Unable to open the file %s\n", l_Dir);
    return 1;
  }

  if(!l_QuietMode)
    PrintBanner();  

  setvbuf(g_lpOutFile, g_OutputBuff, _IOFBF, sizeof(g_OutputBuff)); 
  fprintf(g_lpOutFile,"$BEGIN_MODULE(%s)\n", l_Name);

  if(!l_QuietMode)
    fprintf(stderr,"Parsing %s...\n", argv[argc-1]);
  
  g_FileName = argv[argc-1];
  InitMacros();
  InitEquates();
  InitIncludeStack();

  if(!PushIncludeFile(g_FileName))
  {
    //printf("Error, Unable to open %s",argv[argc-1]);
    return 2;    
  }

//yydebug=1;

  do
  {
    if((l_RetVal = yyparse()))    /* parse a statement   */
    {
      break;
    }
/*
    switch((l_Count++)%4)
    {
      case 0:
        fprintf(stderr,"|\r");
      break;

      case 1:
        fprintf(stderr,"/\r");
      break;

      case 2:
        fprintf(stderr,"-\r");
      break;

      case 3:
        fprintf(stderr,"\\\r");
      break;
    }

    l_Count &= 3;
*/
  } while (!g_EndOfFile);

  fflush(stdout);

  if(l_RetVal)    
    fprintf(stderr, " \nParser terminated with error\n"); 
  else
  {
    if(!l_QuietMode)
      fprintf(stderr, " \nParser terminated without error\n"); 
  }

  fflush(stderr);
  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}
/***************************************************************************/
int yyerror (char *mesg)
{
//  printf("\n%s: %s on line %d\n\t%s\n", GetCurrentFileName(), mesg, g_LineNumber, yytext? yytext: "");
  printf("\n%s: %s on line %d\n\tLast token read was \"%s\"\n", GetCurrentFileName(), mesg, g_LineNumber, yytext? yytext: "");

/*  
  if(g_lpOutFile)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }
*/
  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_OutputFileName);
  remove(g_TempOutputFileName);

  exit(1);
  return 0;
}/* yyerror */
/***************************************************************************/
int yywrap ()
{
  if(PopIncludeFile())
      return 0;
/*
  if(g_lpOutFile)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }
*/
  g_EndOfFile = TRUE;
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}/* yywrap */
/***************************************************************************/
/*
 * fsetpos doesn't resize the file and extra characters remain at the end of 
 * the file. This function resizes the file in an ANSI C compatible fashion.
 */
#ifdef WIN32
#include<io.h>
void  CloseOutputFile(void)
{
  _chsize(fileno(g_lpOutFile),ftell(g_lpOutFile));
  fclose(g_lpOutFile);
  rename(g_TempOutputFileName, g_OutputFileName);
}
#else
void  CloseOutputFile(void)
{
  int     filelength(int);
  FILE    *l_lpTempFile;
  long    l_FilePos;
  char    *l_lpFileName = tmpnam(NULL);
  char    *l_lpBuff = NULL;
  size_t  l_BytesRead;
  long    l_Size = ftell(g_lpOutFile);

  if(!g_lpOutFile)
    return;
  
  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  l_FilePos = ftell(g_lpOutFile);
  rewind(g_lpOutFile);
  l_lpTempFile = fopen(l_lpFileName,"w+");

  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  if(!l_lpBuff)
    l_lpBuff = malloc(l_Size);

  if(!l_lpBuff)
  {
    l_Size = 32768;
    l_lpBuff = malloc(l_Size);
  }

  if(l_lpBuff)
  {

    while((long)(ftell(l_lpTempFile) + l_Size) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }

    if((long)ftell(l_lpTempFile) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }
/*
    while(fread(l_lpBuff, 1,  1,  g_lpOutFile))
    {
      fwrite(l_lpBuff,  1,  1,  l_lpTempFile);
    
      if(l_FilePos == ftell(l_lpTempFile))
      {
        break;
      }
    }
*/
    fclose(l_lpTempFile);
    fclose(g_lpOutFile);

    g_lpOutFile = fopen(g_OutputFileName,"w+");
    l_lpTempFile = fopen(l_lpFileName,"r");

    while((l_BytesRead = fread(l_lpBuff, 1, l_Size, l_lpTempFile)))
      fwrite(l_lpBuff, l_BytesRead, 1, g_lpOutFile);

    free(l_lpBuff);
  }

  fclose(l_lpTempFile);
  fclose(g_lpOutFile);
  remove(l_lpFileName);
  g_lpOutFile = NULL;
}
#endif
/***************************************************************************/
static void CopyIt(char *dst, const char *src, unsigned maxlen)/* Modified Borland C++ 3.1 code */
{                                                              /* for portability */
  if(dst) 
  {
    if(strlen(src) >= maxlen)
    {
      strncpy(dst, src, maxlen);
      dst[maxlen] = 0;
    }
    else
      strcpy(dst, src);
  }
}
/***************************************************************************/
static int DotFound(char *pB)/* Modified Borland C++ 3.1 code */
{                            /* for portability */
  if(*(pB-1) == '.')
    pB--;

  switch (*--pB) 
  {
    case ':'  :
      if(*(pB-2) != '\0')
        break;
    case '/'  :
    case '\\' :
    case '\0' :
    return 1;
  }

  return 0;
}
/***************************************************************************/
int FnSplit(const char *pathP,/* Modified Borland C++ 3.1 code */
            char *driveP,     /* for portability */
            char *dirP,
            char *nameP, 
            char *extP)
{
  char   *pB;
  int    Wrk;
  int     Ret;
  char buf[_MAX_PATH+2];

  /*
    Set all strings to default value zero
  */
  Ret = 0;

  if(driveP)
    *driveP = 0;

  if(dirP)
    *dirP = 0;

  if(nameP)
    *nameP = 0;

  if(extP)
    *extP = 0;

  /*
    Copy filename into template up to _MAX_PATH characters
  */
  pB = buf;

  while (*pathP == ' ')
    pathP++;

  if((Wrk = strlen(pathP)) > _MAX_PATH)
    Wrk = _MAX_PATH;

  *pB++ = 0;
  strncpy(pB, pathP, Wrk);
  *(pB += Wrk) = 0;

  /*
    Split the filename and fill corresponding nonzero pointers
  */
  Wrk = 0;

  for (;;) 
  {
    switch (*--pB) 
    {
      case '.'  :
        if(!Wrk && (*(pB+1) == '\0'))
          Wrk = DotFound(pB);

        if((!Wrk) && ((Ret & EXTENSION) == 0)) 
        {
          Ret |= EXTENSION;
          CopyIt(extP, pB, _MAX_EXT - 1);
          *pB = 0;
        }
      continue;

      case ':'  :
        if(pB != &buf[2])
          continue;

      case '\0' :
        if(Wrk) 
        {
          if(*++pB)
            Ret |= DIRECTORY;

          CopyIt(dirP, pB, _MAX_DIR - 1);
          *pB-- = 0;
          break;
        }

      case '/'  :
      case '\\' :
        if (!Wrk) 
        {
          Wrk++;

          if (*++pB)
            Ret |= FILENAME;

          CopyIt(nameP, pB, _MAX_FNAME - 1);
          *pB-- = 0;

          if (*pB == 0 || (*pB == ':' && pB == &buf[2]))
            break;
        }
      continue;

      case '*'  :
      case '?'  :
        if (!Wrk)
          Ret |= WILDCARDS;

      default :
      continue;
    }
    break;
  }

  if(*pB == ':') 
  {
    if(buf[1])
      Ret |= DRIVE;

    CopyIt(driveP, &buf[1], _MAX_DRIVE - 1);
  }

  return (Ret);
}
/***************************************************************************/
void static SplitPath(const char *pathP,/* Modified Borland C++ 3.1 code */
                      char *driveP,     /* for portability */
                      char *dirP,
                      char *nameP, 
                      char *extP)
{
  (void)FnSplit(pathP,driveP,dirP,nameP,extP);
}

/***************************************************************************/
/***************************** end my yacc source **************************/
/***************************************************************************/
